//ripped from hogwash (hogwash.sf.net) thanks anonpoet
//slightly modded to work with the gobbler

#include "gobbler.h"

#ifdef BSDOS

#include <sys/ioctl.h>
#include <net/bpf.h>
#include <poll.h>

extern int bpffd;

static int bpf_open()
{
        int     fd;
        int     n = 0;
        char    dev[sizeof "/dev/bpf0000000000"];

	//find free bpf device
        do {
                (void) snprintf(dev, sizeof dev, "/dev/bpf%d", n++);
                fd = open(dev, O_RDONLY);
        } while (fd < 0 && errno == EBUSY);

        if (fd < 0) {
                printf("Opps: %s: %s\n\n", device, strerror(errno));
		exit(1);
        }
        return fd;
}

int open_interface(void){
        int     fd;
        struct ifreq ifr;
        u_int   dlt;
        static int immediate = 1;
        static int promisc = 1;

        fd = bpf_open();

        /* Set immediate mode so packets are processed as they arrive. */
        if (ioctl(fd, BIOCIMMEDIATE, &immediate) < 0) {
                printf("Opps: BIOCIMMEDIATE: %s\n\n", strerror(errno));
		exit(1);
        }
        (void) strlcpy(ifr.ifr_name, device, sizeof ifr.ifr_name);
        if (ioctl(fd, BIOCSETIF, (caddr_t) & ifr) < 0) {
                printf("Opps: BIOCSETIF: %s\n\n", strerror(errno));
		exit(1);
        }

        /* Check that the data link layer is an Ethernet; this code won't work
         * with anything else. */
	if (ioctl(fd, BIOCGDLT, (caddr_t) & dlt) < 0) {
                printf("BIOCGDLT: %s\n\n", strerror(errno));
                exit(1);
        }
        if (dlt != DLT_EN10MB) {
                printf("%s is not an ethernet", device);
                exit(1);
        }
        
	/* Switch the interface into promisc mode*/
        if (ioctl(fd, BIOCPROMISC, &promisc) < 0) {
                printf("Couldn't enter promisc mode\n");
                exit(1);
        }
        if (dlt != DLT_EN10MB) {
                printf("%s is not an ethernet", device);
		exit(1);
        }
	
	if(v)printf("BPF sniffer started\n");
        return fd;
}
#endif
