#include "gobbler.h"
#include "nmap.h"

extern u_int16_t srcprt;
extern int srcportoption;
extern int sipcount; //number of source ip's in linked list
extern char* hostname;
extern int portscanstarted;
extern int portscanningstarted;
extern int portscan;
extern int nongportscan;
extern int udpclosedport;
extern int portzerotest;
extern int osdetection;
extern libnet_t *l;
int tseq= 0;
int tseqreply = 0;
int t1 = 0;
int t1reply = 0;
int t1port = 0;
int t2 = 0;
int t2reply = 0;
int t2port = 0;
int t3 = 0;
int t3reply = 0;
int t3port = 0;
int t4 = 0;
int t4reply = 0;
int t4port = 0;
int t5 = 0;
int t5reply = 0;
int t5port = 0;
int t6 = 0;
int t6reply = 0;
int t6port = 0;
int t7 = 0;
int t7reply = 0;
int t7port = 0;
int pu = 0;
int pureply = 0;
int p1 = 0; //port zero test 1
int p1reply = 0;
int p1src = 0;
int p1dst = 0;
int p2 = 0;
int p2reply = 0;
int p2src = 0;
int p2dst = 0;
int p3 = 0;
int p3reply = 0;
int p3src = 0;
int p3dst = 0;
int p4 = 0;
int p4reply = 0;
int p4src = 0;
int p4dst = 0;
int p5 = 0;
int p5reply = 0;
int p5src = 0;
int p5dst = 0;
u_int16_t p5id = 0;
int p6 = 0;
int p6reply = 0;
int p6src = 0;
int p6dst = 0;
u_int16_t p6id = 0;
int p7 = 0;
int p7reply = 0;
int p7src = 0;
int p7dst = 0;
u_int16_t p7id = 0;
u_int16_t puid = 0;
u_int8_t patternbyte = 0;
u_int16_t udpck = 0;
int osdetect = 0;
extern FingerPrint *FPs[10];
extern FingerPrint **reference_FPs;
struct FingerPrintResults FPR;
struct timeval seq_send_times[NUM_SEQ_SAMPLES];

extern FingerPrint *PFPs[10];
extern FingerPrint **portzero_FPs;
struct FingerPrintResults PFPR;

u_int32_t t1seq = 0;
u_int32_t t2seq = 0;
u_int32_t t3seq = 0;
u_int32_t t4seq = 0;
u_int32_t t5seq = 0;
u_int32_t t6seq = 0;
u_int32_t t7seq = 0;
#ifndef MAX
#define MAX(x,y) (((x)>(y))?(x):(y))
#endif

int testcounter;
int portzerotestcounter;
//send nmap OS detection packets
int start_osdetection(void)
{
	extern int tcpipethpacket(u_short srcport, u_long srcip, u_char *srcmac, u_short dstport, u_long dstip, u_char *dstmac, u_char flags, int options, int seqnum);
	extern int portllcount(void); //open ports cound
	extern int cportllcount(void); //closed port count
	struct FingerPrintResults FP_matches[1]; //nmap 
	struct FingerPrintResults PFP_matches[1]; //port 0 fingerprint
	int udpipethpacket(u_short srcport, u_long srcip, u_char *srcmac, u_short dstport, u_long dstip, u_char *dstmac, u_int16_t puid);
	extern void *safe_zalloc(int size);
	
	extern void match_fingerprint(FingerPrint *FP, struct FingerPrintResults *FPR,	FingerPrint **reference_FPs, double accuracy_threshold);
	extern char *fp2ascii(FingerPrint *FP);	
	double bestacc;
	int bestaccidx;
	int opencount = 0;
	int closedcount = 0;
	int randnum = 0;
	int noopen = 0;
	int noclosed = 0;
	int a = 0;
	int openport = 0;
	int closedport = 0;
	int b = 0;
	int d = 0;
	int i = 0;
	struct in_addr sa;
	int seq_packets_sent = 0;
	u_int32_t seq = 0;
	port *o_curr = NULL; //open port linked list
	cport *c_curr = NULL; //closed port linked list
	int k = 0;
	PMT i_curr; //source ip n mac llinked
	PMI m_curr; //target mac addr
	struct AVal *AVsa = NULL, *AVsb = NULL, *AVsc = NULL, *AVsd = NULL, *AVse = NULL, *AVsf = NULL, *AVsg = NULL, *AVsh = NULL;
	struct AVal *AVpa = NULL, *AVpb = NULL, *AVpc = NULL, *AVpd = NULL, *AVpe = NULL, *AVpf = NULL, *AVpg = NULL;
	//struct AVal *seq_AVs;
	//struct seq_info *si;
	int doneonce = 0;
	testcounter = 0;
	portzerotestcounter = 0;
	if(!inet_aton(hostname, &sa)){
                printf("\nOpps: %s is a invalid ip address\n", hostname);
                exit(1);
        }

	portscanstarted = 0;
	portscanningstarted = 0;
	portscan = 0;
	nongportscan = 0;
	//count closed and open ports
	opencount = portllcount();

	if(opencount == 0){
		printf("OS detection will be less accurate as no open ports were found\n");
		noopen = 1;
	}

	else {
		o_curr = portpoint;
	}

	closedcount = cportllcount();
	
	if(closedcount == 0){
		printf("OS detection will be less accurate as no closed ports were found\n");
		noclosed = 1;
	}

	else{
		c_curr = cportpoint;
	}
	if(!noopen){
		randnum = 1 + (int)((float)opencount*rand()/(RAND_MAX+1.0));
		a = 0;
		while((o_curr != NULL) && (a != (randnum -1))){
       	        	a++;
                	o_curr = (POPT) o_curr->nextport;
        	}

		if(o_curr == NULL){
			printf("Opps: couldn't find a open port for OS detection in linked list\n\n");
			return(1);
		}

		openport = o_curr->num;
	}

	if(!noclosed){
		//eg closed ports found
		randnum = 1 + (int)((float)closedcount*rand()/(RAND_MAX+1.0));
		a = 0;
		while((c_curr != NULL) && (a != (randnum -1))){
       	                a++;
               	        c_curr = (COPT) c_curr->nextport;
   		}

		if(c_curr == NULL){
			printf("Opps: couldn't find a open port for OS detection in linked list\n\n");
			return(1);
		}

		closedport = c_curr->num;
	}

	
	if(v>1)printf("open count %d, closed count %d, openport %d, closedport %d\n", opencount, closedcount, openport, closedport);


	//find random source ip
	i_curr = mtpoint;
	if(i_curr == NULL){
                printf("Opps: src ip ll is empty\n\n");
                return(1);
        }

        randnum = 1 + (int)((float)sipcount*rand()/(RAND_MAX+1.0));
	a = 0;
       	while((i_curr != NULL) && (a != (randnum -1))){
        	a++;
                i_curr = (PMT) i_curr->nextmt;
        }
	
        if(i_curr == NULL){
        	printf("Opps: couldn't find a src IP address\n\n");
                exit(1);
        }
	
	//find dstmac
	m_curr = macippoint;
	if(m_curr == NULL){
	        printf("Opps: target mac addr is empty\n\n");
        	return(1);
        }
	
	if(osdetection){
		osdetect = 1; //signal sniffer to deocde on basis of os detect scan
		//nmap tests
		//test 1
		//SYN to a open port
		if(!noopen){
			t1 = 1;
			if(!srcportoption){
				srcprt = libnet_get_prand(LIBNET_PRu16);
			}
			///source port, ip, mac, dest port, ip, mac, tcp flags, tcp options switch
			if(v>1)printf("\nPerforming OS test 1... SYN flag to a open port\n");
			t1seq = libnet_get_prand(LIBNET_PRu32);
			t1port = srcprt;
			//printf("t1seq %x\n",t1seq\n);
			tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, openport, sa.s_addr, m_curr->srcmac, TH_SYN, 1, t1seq);
			for(b=0; b<20;b++){
				if(t1reply == 1) b = 20;
				usleep(250000);
			}
			t1 = 0;
			if(!t1reply){
				FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
               		        FPs[testcounter]->name = "T1";

				AVsa = (struct AVal *) malloc(1 * sizeof(struct AVal));
				AVsa[0].next = NULL;
			
				AVsa[0].attribute = "Resp";
				strcpy(AVsa[0].value, "N");
				
				FPs[testcounter]->results = AVsa; //(struct AVal *) malloc(6 * sizeof(struct AVal));
				testcounter++;
				printf("T1(Resp=N)\n");
			}
	
			//test 2
			//NULL to open port
			t2 = 1;
			if(v>1)printf("\nPerforming OS test 2... No TCP flags to a open port\n");
			if(!srcportoption){
				srcprt = libnet_get_prand(LIBNET_PRu16);
			}
			t2seq = libnet_get_prand(LIBNET_PRu32);
			t2port = srcprt;
			tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, openport, sa.s_addr, m_curr->srcmac, 0, 1, t2seq);
			for(b=0; b<20;b++){
				if(t2reply == 1) b = 20;
				usleep(250000);
			}
			t2 = 0;
			if(!t2reply){
				FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
       		                FPs[testcounter]->name = "T2";
	
	
				AVsb = (struct AVal *) malloc(1 * sizeof(struct AVal));
				AVsb[0].next = NULL;
				
				AVsb[0].attribute = "Resp";
				strcpy(AVsb[0].value, "N");
				
				FPs[testcounter]->results = AVsb; 
				testcounter++;
				printf("T2(Resp=N)\n");
			}
	
			//test 3
			//SYN FIN URG PSH to open port
			t3 = 1; 
			if(v>1)printf("\nPerforming OS test 3... SYN FIN URG PSH flags to open port\n");
			if(!srcportoption){
				srcprt = libnet_get_prand(LIBNET_PRu16);
			}
			t3seq = libnet_get_prand(LIBNET_PRu32);
			t3port = srcprt;
			tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, openport, sa.s_addr, m_curr->srcmac, TH_SYN + TH_FIN + TH_URG + TH_PUSH, 1, t3seq);
			for(b=0; b<20;b++){
				if(t3reply == 1) b = 20;
				usleep(250000);
			}
			t3 = 0;
			if(!t3reply){
				FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                       		FPs[testcounter]->name = "T3";


				AVsc = (struct AVal *) malloc(1 * sizeof(struct AVal));
				AVsc[0].next = NULL;
			
				AVsc[0].attribute = "Resp";
				strcpy(AVsc[0].value, "N");
			
				FPs[testcounter]->results = AVsc; 
				testcounter++;
				printf("T3(Resp=N)\n");
			}
	
			//test 4
			//ack to open port
			t4 = 1;
			if(v>1)printf("\nPerforming OS test 4... ACK to open port\n");
			if(!srcportoption){
				srcprt = libnet_get_prand(LIBNET_PRu16);
			}
			t4seq = libnet_get_prand(LIBNET_PRu32);
			t4port = srcprt;
			tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, openport, sa.s_addr, m_curr->srcmac, TH_ACK, 1, t4seq);
			for(b=0; b<20;b++){
				if(t4reply == 1) b = 20;
				usleep(250000);
			}	
			t4 = 0;
			if(!t4reply){
				FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        	FPs[testcounter]->name = "T4";


				AVsd = (struct AVal *) malloc(1 * sizeof(struct AVal));
				AVsd[0].next = NULL;
			
				AVsd[0].attribute = "Resp";
				strcpy(AVsd[0].value, "N");
			
				FPs[testcounter]->results = AVsd; 
				testcounter++;
				printf("T4(Resp=N)\n");
			}
		} //end of if open port available

		if(!noclosed){	
			//test 5
			//SYN to a closed port
			t5 = 1;
			if(v>1)printf("\nPerforming OS test 5... SYN to a closed port\n");
			if(!srcportoption){
	       		        srcprt = libnet_get_prand(LIBNET_PRu16);
	        	}
			t5seq = libnet_get_prand(LIBNET_PRu32);
			t5port = srcprt;
	        	tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, closedport, sa.s_addr, m_curr->srcmac, TH_SYN, 1, t5seq);
			for(b=0; b<20;b++){
				if(t5reply == 1) b = 20;
				usleep(250000);
			}
			t5 = 0;
			if(!t5reply){
				FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                       		FPs[testcounter]->name = "T5";


				AVse = (struct AVal *) malloc(1 * sizeof(struct AVal));
				AVse[0].next = NULL;
			
				AVse[0].attribute = "Resp";
				strcpy(AVse[0].value, "N");
			
				FPs[testcounter]->results = AVsb; 
				testcounter++;
				printf("T5(Resp=N)\n");
			}
	
			//test 6
			//ack to closed port
			t6 = 1;
			if(v>1)printf("\nPerforming OS test 6... ACK to a closed port\n");
			if(!srcportoption){
		        	srcprt = libnet_get_prand(LIBNET_PRu16);
        		}
			t6seq = libnet_get_prand(LIBNET_PRu32);
			t6port = srcprt;
        		tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, closedport, sa.s_addr, m_curr->srcmac, TH_ACK, 1, t6seq);
			for(b=0; b<20;b++){
				if(t6reply == 1) b = 20;
				usleep(250000);
			}
			t6 = 0;
			if(!t6reply){
				FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        	FPs[testcounter]->name = "T6";


				AVsf = (struct AVal *) malloc(1 * sizeof(struct AVal));
				AVsf[0].next = NULL;
			
				AVsf[0].attribute = "Resp";
				strcpy(AVsf[0].value, "N");
			
				FPs[testcounter]->results = AVsf; 
				testcounter++;
				printf("T6(Resp=N)\n");
			}
	
			//test 7
			//FIN PUSH URG to closed port
			t7 = 1;
			if(v>1)printf("\nPerforming OS test 7... FIN PUSH URG to a closed port\n");
			if(!srcportoption){
                		srcprt = libnet_get_prand(LIBNET_PRu16);
        		}
			t7seq = libnet_get_prand(LIBNET_PRu32);
			t7port = srcprt;
       			tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, closedport, sa.s_addr, m_curr->srcmac, TH_FIN + TH_PUSH + TH_URG, 1, t7seq);
			for(b=0; b<20;b++){
				if(t7reply == 1) b = 20;
				usleep(250000);
			}
			t7 = 0;
			if(!t7reply){
				FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                       		FPs[testcounter]->name = "T7";
	
	
				AVsg = (struct AVal *) malloc(1 * sizeof(struct AVal));
				AVsg[0].next = NULL;
			
				AVsg[0].attribute = "Resp";
				strcpy(AVsg[0].value, "N");
			
				FPs[testcounter]->results = AVsg; 
				testcounter++;
				printf("T7(Resp=N)\n");
			}
		}
		//test 8
		//port unreachable
		pu = 1;
		if(v>1)printf("\nPerforming OS test 8... udp to closed port\n");
	
		if(!srcportoption){
               		srcprt = 53; //might bypass some lame firewall rules
			//libnet_get_prand(LIBNET_PRu16);
       		}
		puid = libnet_get_prand(LIBNET_PRu16);
		udpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, udpclosedport, sa.s_addr, m_curr->srcmac, puid);
		for(b=0; b<20; b++){
			if(pureply == 1) b = 20;
			usleep(250000);
		}

		pu = 0;	
		if(!pureply){
               		FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                	FPs[testcounter]->name = "PU";
			AVsh = (struct AVal *) malloc(1 * sizeof(struct AVal));
                	AVsh[0].next = NULL;

                	AVsh[0].attribute = "Resp";
                	strcpy(AVsh[0].value, "N");

                	FPs[testcounter]->results = AVsh;
			if(!noclosed || !noopen)printf("PU(Resp=N)\n");
		}

	
		//SequenAce number class test
		//TODO sniffer side TODO
		if(!noopen){
			tseq = 1;
			if(v)printf("Performing OS Sequence number tests.... 6 SYN packets\n");
		//	bzero(si, sizeof(si));
		//	si->ipid_seqclass = IPID_SEQ_UNKNOWN;
		//	si->ts_seqclass = TS_SEQ_UNKNOWN;
		//	si->lastboot = 0;
		
		//	FPs[0] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
		//	FPs[0]->name = "TSeq";
		//seq_AVs = (struct AVal *) safe_zalloc( sizeof(struct AVal) * 5);
		//	printf("end a\n");
		//FPs[0]->results = seq_AVs;
	
			while(seq_packets_sent < NUM_SEQ_SAMPLES){
				if(!srcportoption){
                			srcprt = libnet_get_prand(LIBNET_PRu16);
        			}
				seq = libnet_get_prand(LIBNET_PRu32);
       				tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, openport, sa.s_addr, m_curr->srcmac, TH_SYN, 0, seq);
				usleep(110000); //TODO usleep( MAX(110000, target->to.srtt));
				//printf("b4 timeofday\n");
				gettimeofday(&seq_send_times[seq_packets_sent], NULL);
				seq_packets_sent++;
			}
		
			tseq = 0;
		
			if(v) { 
				for(d=0; d<NUM_SEQ_SAMPLES; d++){
					printf("%d sequence send times %ld.%ld\n", d, seq_send_times[d].tv_sec, seq_send_times[d].tv_usec);
				}
			}
		}
	
		printf("\n");

		for(i=0;i<testcounter;i++){
			FPs[i]->next = FPs[i+1];
			if(i == (testcounter -1)) FPs[i]->next = NULL;
		}

		//do the matching
		bzero(FP_matches, sizeof(FP_matches));
		match_fingerprint(*FPs, &FP_matches[0],
                     reference_FPs, OSSCAN_GUESS_THRESHOLD);

		bestacc = 0;
		bestaccidx = 0;
		memcpy(&(FPR), FP_matches + bestaccidx, sizeof(FPR)); //FP + bset always 0

		if(v)printf("perfect matches %d, num matches %d\n", FPR.num_perfect_matches, FPR.num_matches);
	
		if(FPR.num_perfect_matches){
			printf("%d possible remote OS types found by Nmap fingerprinting\n", FPR.num_perfect_matches);
			k = 0;
			while(FPR.accuracy[k] == 1 ) {
	        		printf("%d. %s\n", k +1 , FPR.prints[k]->OS_name);
        			k++;
	       		}	
			printf("\n");
		}
		if(!FPR.num_perfect_matches && FPR.num_matches){
			k = 0;
			printf("%d possible remote OS types with accuracy != 1 found by Nmap fingerprinting\n", FPR.num_matches);
			while(k != FPR.num_matches) {
       		 		printf("%d. %s\n", k+1,FPR.prints[k]->OS_name);
		        	k++;
        		}
			printf("\n");
		}
	
		if(!FPR.num_perfect_matches && !FPR.num_matches){
			printf("Doh.... couldn;t get OS match\n");
		}

		printf("\n");
	}
	
	if(portzerotest){
		osdetect = 1;
		printf("Port 0 testing\n");
		if(noopen){
			printf("Port 0 testing will be less reliable as no open ports were found\n");
		}
		if(noclosed){
			printf("Port 0 testing will be less reliable as no closed ports were found\n");
		}
		p1 = 1;
		if(v)printf("P1: send tcp packet from source port 0 to port 0\n");
		seq = libnet_get_prand(LIBNET_PRu32);
		p1dst = 0;
		p1src = 0;
                tcpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, 0, sa.s_addr, m_curr->srcmac, TH_SYN, 0, seq);
		 for(b=0; b<20;b++){
                        if(p1reply == 1) b = 20;
                        usleep(250000);
			if(b==10 && !doneonce){
				tcpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, 0, sa.s_addr, m_curr->srcmac, TH_SYN, 0, seq);
				b = 0;
				doneonce = 1;
			}
                }
		p1 = 0;
		doneonce = 0;
		if(!p1reply){

			PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P1";

                        AVpa = (struct AVal *) malloc(1 * sizeof(struct AVal));
                        AVpa[0].next = NULL;

                        AVpa[0].attribute = "Resp";
                        strcpy(AVpa[0].value, "N");

                        PFPs[portzerotestcounter]->results = AVpa; 
                        portzerotestcounter++;

			printf("P1(Resp=N)\n");
		}

		p2 = 1;
		if(!srcportoption){
                	//srcprt = 53; //might bypass some lame firewall rules
	                srcprt = libnet_get_prand(LIBNET_PRu16);
        	}

		if(v)printf("P2: send tcp packet from source port %d to port 0\n",srcprt);
		seq = libnet_get_prand(LIBNET_PRu32);
		p2src = srcprt;
		p2dst = 0;
                tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, 0, sa.s_addr, m_curr->srcmac, TH_SYN, 0, seq);
		for(b=0; b<20;b++){
                        if(p2reply == 1) b = 20;
                        usleep(250000);
                	if(b==10 && !doneonce){
				tcpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, 0, sa.s_addr, m_curr->srcmac, TH_SYN, 0, seq);
				b = 0;
				doneonce = 1;
			}
		}
		p2 = 0;
		doneonce = 0;
		if(!p2reply) {
			PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P2";

                        AVpb = (struct AVal *) malloc(1 * sizeof(struct AVal));
                        AVpb[0].next = NULL;

                        AVpb[0].attribute = "Resp";
                        strcpy(AVpb[0].value, "N");

                        PFPs[portzerotestcounter]->results = AVpb; //(struct AVal *) malloc(6 * sizeof(struct AVal));
                        portzerotestcounter++;

			printf("P2(Resp=N)\n");
		}

		if(!noopen){
			p3 = 1;
			if(v)printf("P3: send tcp packet from source port 0 to open port %d\n",openport);
			seq = libnet_get_prand(LIBNET_PRu32);
			p3src = 0;
			p3dst = openport;
 	                tcpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, openport, sa.s_addr, m_curr->srcmac, TH_SYN, 0, seq);
			for(b=0; b<20;b++){
	                        if(p3reply == 1) b = 20;
        	                usleep(250000);
				if(b==10 && !doneonce){
					tcpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, openport, sa.s_addr, m_curr->srcmac, TH_SYN, 0, seq);
					b = 0;
					doneonce = 1;
				}
                	}
			p3 = 0;
			doneonce = 0;
			if(!p3reply){
	                        PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
        	                PFPs[portzerotestcounter]->name = "P3";

                	        AVpc = (struct AVal *) malloc(1 * sizeof(struct AVal));
                        	AVpc[0].next = NULL;

	                        AVpc[0].attribute = "Resp";
       		                strcpy(AVpc[0].value, "N");

                	        PFPs[portzerotestcounter]->results = AVpc; //(struct AVal *) malloc(6 * sizeof(struct AVal));
                	        portzerotestcounter++;

				printf("P3(Resp=N)\n");
			}
		}

		if(!noclosed){
			p4 = 1;
			if(v)printf("P4: send tcp packet from source port 0 to closed port %d\n",closedport);
			seq = libnet_get_prand(LIBNET_PRu32);
			p4src = 0;
			p4dst = closedport;
                        tcpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, closedport, sa.s_addr, m_curr->srcmac, TH_SYN, 0, seq);
			for(b=0; b<20;b++){
                                if(p4reply == 1) b = 20;
                                usleep(250000);
                        	if(b==10 && !doneonce){
					tcpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, closedport, sa.s_addr, m_curr->srcmac, TH_SYN, 0, seq);
					b = 0;
					doneonce = 1;
				}
			}	
			p4 = 0;
			doneonce = 0;
			if(!p4reply){
	                        PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
	                        PFPs[portzerotestcounter]->name = "P4";

                                AVpd = (struct AVal *) malloc(1 * sizeof(struct AVal));
                 	        AVpd[0].next = NULL;
	
	                        AVpd[0].attribute = "Resp";
	                        strcpy(AVpd[0].value, "N");

                 	        PFPs[portzerotestcounter]->results = AVpd; //(struct AVal *) malloc(6 * sizeof(struct AVal));
                       		portzerotestcounter++;

				printf("P4(Resp=N)\n");
			}
		}
		
		p5 = 1;
		if(v)printf("P5: send udp packet from source port 0 to port 0\n");
        	if(!srcportoption){
                	srcprt = 53; //might bypass some lame firewall rules
	                //libnet_get_prand(LIBNET_PRu16);
        	}
	        p5id = libnet_get_prand(LIBNET_PRu16);
		p5src = 0;
		p5dst = 0;
        	udpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, 0, sa.s_addr, m_curr->srcmac, p5id);
	        for(b=0; b<20; b++){
        	        if(p5reply == 1) b = 20;
                	usleep(250000);
			if(b==10 && !doneonce){
				udpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, 0, sa.s_addr, m_curr->srcmac, p5id);
				b = 0;
				doneonce = 1;
			}
	        }
		p5 = 0;
		doneonce = 0;
		if(!p5reply){
                        PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P5";

                        AVpe = (struct AVal *) malloc(1 * sizeof(struct AVal));
                        AVpe[0].next = NULL;

                        AVpe[0].attribute = "Resp";
                        strcpy(AVpe[0].value, "N");

                        PFPs[portzerotestcounter]->results = AVpe; //(struct AVal *) malloc(6 * sizeof(struct AVal));
                        portzerotestcounter++;

			printf("P5(Resp=N)\n");
		}
 
                p6 = 1;
                if(!srcportoption){
                        srcprt = 53; //might bypass some lame firewall rules
                        //libnet_get_prand(LIBNET_PRu16);
                }
                if(v)printf("P6: send udp packet from source port %d to port 0\n",srcprt);
                p6id = libnet_get_prand(LIBNET_PRu16);
                p6src = srcprt;
                p6dst = 0;
                udpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, 0, sa.s_addr, m_curr->srcmac, p6id);
                for(b=0; b<20; b++){
                        if(p6reply == 1) b = 20;
                        usleep(250000);
			if(b==10 && !doneonce){
				udpipethpacket(srcprt, i_curr->ipaddress, i_curr->srcmac, 0, sa.s_addr, m_curr->srcmac, p6id);
				b = 0;
				doneonce = 1;
			}
                }
                p6 = 0;
		doneonce = 0;
                if(!p6reply){
                        PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P6";

                        AVpf = (struct AVal *) malloc(1 * sizeof(struct AVal));
                        AVpf[0].next = NULL;

                        AVpf[0].attribute = "Resp";
                        strcpy(AVpf[0].value, "N");

                        PFPs[portzerotestcounter]->results = AVpf; //(struct AVal *) malloc(6 * sizeof(struct AVal));
                        portzerotestcounter++;

			printf("P6(Resp=N)\n");
		}

		p7 = 1;
                if(!srcportoption){
                        srcprt = 53; //might bypass some lame firewall rules
                        //libnet_get_prand(LIBNET_PRu16);
                }
                if(v)printf("P7: send udp packet from source port 0 to closed port %d\n",udpclosedport);
                p7id = libnet_get_prand(LIBNET_PRu16);
                p7src = 0;
                p7dst = udpclosedport;
                udpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, udpclosedport, sa.s_addr, m_curr->srcmac, p7id);
                for(b=0; b<20; b++){
                        if(p7reply == 1) b = 20;
                        usleep(250000);
			if(b==10 && !doneonce){
				udpipethpacket(0, i_curr->ipaddress, i_curr->srcmac, udpclosedport, sa.s_addr, m_curr->srcmac, p7id);
				b = 0;
				doneonce = 1;
			}
                }
                p7 = 0;
		doneonce = 0;
                if(!p7reply){
                        PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P7";

                        AVpg = (struct AVal *) malloc(1 * sizeof(struct AVal));
                        AVpg[0].next = NULL;

                        AVpg[0].attribute = "Resp";
                        strcpy(AVpg[0].value, "N");

                        PFPs[portzerotestcounter]->results = AVpg; //(struct AVal *) malloc(6 * sizeof(struct AVal));
                        portzerotestcounter++;

			printf("P7(Resp=N)\n");
		}
        //do the matching
 	      
		for(i=0;i<portzerotestcounter;i++){
        	        PFPs[i]->next = PFPs[i+1];
               		if(i == (portzerotestcounter -1)) PFPs[i]->next = NULL;
        	}
		bzero(PFP_matches, sizeof(PFP_matches));
	        match_fingerprint(*PFPs, &PFP_matches[0],
	                     portzero_FPs, OSSCAN_GUESS_THRESHOLD);

      		bestacc = 0;
        	bestaccidx = 0;
        	memcpy(&(PFPR), PFP_matches + bestaccidx, sizeof(PFPR)); //FP + bset always 0
		printf("\n");
        	if(v)printf("perfect matches %d, num matches %d\n", PFPR.num_perfect_matches, PFPR.num_matches);

        	if(PFPR.num_perfect_matches){
                	printf("%d possible remote OS types found by port 0 fingerprinting\n", PFPR.num_perfect_matches);
                	k = 0;
                	while(PFPR.accuracy[k] == 1 ) {
                	        printf("%d. %s\n", k +1 , PFPR.prints[k]->OS_name);
                	        k++;
                	}
                	printf("\n");
        	}
        	if(!PFPR.num_perfect_matches && PFPR.num_matches){
                	k = 0;
                	printf("%d possible remote OS types with accuracy != 1 found by port 0 fingerprinting\n", PFPR.num_matches);
                	while(k != PFPR.num_matches) {
                	        printf("%s\n", PFPR.prints[k]->OS_name);
                	        k++;
                	}
                	printf("\n");
        	}

        	if(!PFPR.num_perfect_matches && !PFPR.num_matches){
        	        printf("Doh.... couldn;t get OS match\n");
        	}

        	printf("\n");
		printf("End of port 0 scanning\n\n");
	}
	return(0);
}


int udpipethpacket(u_short srcport, u_long srcip, u_char *srcmac, u_short dstport, u_long dstip, u_char *dstmac, u_int16_t puid)
{
	#define PLOADS 300
	extern unsigned int get_random_uint();
	unsigned short in_cksum(u_int16_t *ptr, int nbytes);
	libnet_ptag_t t;
	u_char payload[PLOADS]; 
	u_char *pp = payload;
	u_int payloads = PLOADS;
	struct {
		unsigned int saddr;
		unsigned int daddr;
		unsigned char placeholder;
		unsigned char protocol;
		unsigned short udp_length;
		struct my_udp udp;
		char data[PLOADS];
	} pseudo;


	if (!patternbyte) patternbyte = (get_random_uint() % 60) + 65;
	memset(payload, patternbyte, PLOADS);

	t = libnet_build_udp(
		srcport,	//src port
		dstport,	//dst port
		LIBNET_UDP_H + payloads,	//length
		0,		//sum
        	pp, 		//payload
		payloads,	//payload size
		l,		//libnet handle
		0);		//libnet if
	if(t == -1){
                printf("Opps: libnet_build_ipv4 error as %s\n\n", libnet_geterror(l));
                exit(1);
        }	

	t = libnet_build_ipv4(
        	LIBNET_UDP_H + LIBNET_IPV4_H + payloads, //length
                0,              //TOS
                puid,           //id,
                0,              //IP frag
                GOBTTL,         //TTL
                IPPROTO_UDP,    //protocol
                0,              //checksum
                srcip,  	//srcip
                dstip,  	//dstip
                NULL,           //payload
                0,              //sizeof payload
                l,              //libnet handle
                0);             //libnet id
	if(t == -1){
        	printf("Opps: libnet_build_ipv4 error as %s\n\n", libnet_geterror(l));
                exit(1);
	}
	
        t = libnet_build_ethernet(
                dstmac,//-1,//dstmac,         //dst mac
                srcmac,//srcmac,         //src mac
                ETHERTYPE_IP,   //proto
                NULL,           //payload
                0,              //payload size
                l,              //libnet handle
                0);             //libnet id
        if(t == -1){
                printf("Opps: libnet_build_ethernet error as %s\n\n", libnet_geterror(l));
                exit(1);
        }
        
	//build pseudo to calculate checksum b4 it gets sent down the wire
	pseudo.saddr = srcip;
	pseudo.daddr = dstip;
	pseudo.placeholder = 0;
	pseudo.protocol = IPPROTO_UDP; 
	pseudo.udp_length = htons(LIBNET_UDP_H + payloads);
	pseudo.udp.src_port = htons(srcport);
	pseudo.udp.dst_port = htons(dstport);
	pseudo.udp.udp_length = htons(LIBNET_UDP_H + payloads);
	pseudo.udp.chksum = 0;
	bcopy(payload, pseudo.data, PLOADS);
	udpck = in_cksum((unsigned short *)&pseudo, 12 + LIBNET_UDP_H + payloads);
	if(v>1)printf("pseudo UDP checksum %x\n", udpck);
	if(libnet_write(l) == -1){
                printf("Opps: libnet_write error (udpipeth) as %s\n",libnet_geterror(l));
                exit(1);
        }
	
        libnet_stats(l, &gs);
        libnet_clear_packet(l);
        return(0);
}


//try to find inital ttl
int getinitttl(int ttl)
{
	int tempttl = 0;
	
	//check to find inital TTL (lame guessing)
       	if((ttl <= 255) && (ttl > 128)){
		tempttl = 255;
	}

       	if((ttl <= 128) &&  (ttl > 64)){
		tempttl = 128;
	}

        if((ttl <= 64) && (ttl >32)){
		tempttl = 64;
	}

        if(ttl <= 32){
		tempttl = 32;
	}
	
	return(tempttl);
}

